<?php
/**
* @version 1.3.0
* @package RSform!Pro 1.3.0
* @copyright (C) 2007-2010 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * RSForm! Pro system plugin
 */
class plgSystemRSFPbitpay extends JPlugin
{
	var $_products = array();
	
	/**
	 * Constructor
	 *
	 * For php4 compatibility we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemRSFPbitpay( &$subject, $config )
	{
		parent::__construct( $subject, $config );
		$this->newComponents = array(21,22,23);
		
		global $_products;
	}
	
	function canRun()
	{
		if (class_exists('RSFormProHelper')) return true;
		
		$helper = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsform'.DS.'helpers'.DS.'rsform.php';
		if (file_exists($helper))
		{
			require_once($helper);
			RSFormProHelper::readConfig();
			return true;
		}
		
		return false;
	}
	
	/*
		Event Triggered Functions
	*/
	function rsfp_bk_onInit()
	{
		if (!$this->canRun()) return;
		
		$formId = JRequest::getInt('formId');
		
		$db = &JFactory::getDBO();
		//Cron that sets non paid subscribers to denied after 12 h
		$db->setQuery("UPDATE #__rsform_submission_values sv LEFT JOIN #__rsform_submissions s ON s.SubmissionId=sv.SubmissionId SET sv.FieldValue=-1 WHERE sv.FieldName = '_STATUS' AND sv.FieldValue = 0 AND s.DateSubmitted < '".date('Y-m-d H:i:s',strtotime('-12 hours'))."'");
		$db->query();
	}
	
	function rsfp_bk_onAfterShowComponents()
	{
		if (!$this->canRun()) return;
		
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpbitpay' );
		
		$mainframe =& JFactory::getApplication();
		$db = JFactory::getDBO();
		$formId = JRequest::getInt('formId');
		
		$link1 = "displayTemplate('21')";
		$link2 = "displayTemplate('23')";
		if ($components = RSFormProHelper::componentExists($formId, 21))
			$link1 = "displayTemplate('21', '".$components[0]."')";
		if ($components = RSFormProHelper::componentExists($formId, 23))
			$link2 = "displayTemplate('23', '".$components[0]."')";
			
		?>
		<li class="rsform_navtitle"><?php echo JText::_('RSFP_bitpay_LABEL'); ?></li>
		<li><a href="javascript: void(0);" onclick="<?php echo $link1;?>;return false;" id="rsfpc21"><span id="bitpay"><?php echo JText::_('RSFP_bitpay_SPRODUCT'); ?></span></a></li>
		<li><a href="javascript: void(0);" onclick="displayTemplate('22');return false;" id="rsfpc22"><span id="bitpay"><?php echo JText::_('RSFP_bitpay_MPRODUCT'); ?></span></a></li>
		<li><a href="javascript: void(0);" onclick="<?php echo $link2;?>;return false;" id="rsfpc23"><span id="bitpay"><?php echo JText::_('RSFP_bitpay_TOTAL'); ?></span></a></li>
		<?php
	}
	
	
	function rsfp_bk_onAfterCreateComponentPreview($args = array())
	{
		if (!$this->canRun()) return;
		
		$nodecimals = RSFormProHelper::getConfig('bitpay.nodecimals');
		$decimal    = RSFormProHelper::getConfig('bitpay.decimal');
		$thousands  = RSFormProHelper::getConfig('bitpay.thousands');
		$currency   = RSFormProHelper::getConfig('bitpay.currency');
		
		switch ($args['ComponentTypeName'])
		{
			case 'bitpaySingleProduct':
				$args['out'] = '<td>'.$args['data']['CAPTION'].'</td>';
				$args['out'].= '<td><img src="'.JURI::root(true).'/administrator/components/com_rsform/assets/images/icons/bitpay.png" /> '.$args['data']['CAPTION'].' - '.number_format($args['data']['PRICE'], $nodecimals, $decimal, $thousands).' '.$currency.'</td>';	
			break;
			
			case 'bitpayMultipleProducts':
				$args['out'] = '<td>'.$args['data']['CAPTION'].'</td>';
				$args['out'].= '<td><img src="'.JURI::root(true).'/administrator/components/com_rsform/assets/images/icons/bitpay.png" /> '.$args['data']['CAPTION'].'</td>';
			break;
			
			case 'bitpayTotal':
				$args['out'] = '<td>'.$args['data']['CAPTION'].'</td>';
				$args['out'].= '<td>'.number_format(0, $nodecimals, $decimal, $thousands).' '.$currency.'</td>';	
			break;
		}
	}
	
	function rsfp_bk_onAfterShowConfigurationTabs()
	{
		if (!$this->canRun()) return;
		
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpbitpay' );
		
		jimport('joomla.html.pane');
		$tabs =& JPane::getInstance('Tabs', array(), true);
		
		echo $tabs->startPanel(JText::_('RSFP_bitpay_LABEL'), 'form-bitpay');
			$this->bitpayConfigurationScreen();
		echo $tabs->endPanel();
	}
	
	function rsfp_bk_onAfterCreateFrontComponentBody($args)
	{
		if (!$this->canRun()) return;
		
		RSFormProHelper::readConfig(true);
		$nodecimals = RSFormProHelper::getConfig('bitpay.nodecimals');
		$decimal    = RSFormProHelper::getConfig('bitpay.decimal');
		$thousands  = RSFormProHelper::getConfig('bitpay.thousands');
		$currency   = RSFormProHelper::getConfig('bitpay.currency');
		
		$value = $args['value'];
		
		switch($args['r']['ComponentTypeId'])
		{
			case 21:
			{
				if(isset($args['data']['SHOW']) && $args['data']['SHOW']=='NO')
				{
					//Hidden
					$args['out'] = '<input type="hidden" name="rsfp_bitpay_item[]" value="'.RSFormProHelper::htmlEscape($args['data']['PRICE']).'"/>
					<input type="hidden" name="form['.$args['data']['NAME'].']" id="'.$args['data']['NAME'].'" value="'.RSFormProHelper::htmlEscape($args['data']['CAPTION']).'"/>';
				}
				else
				{
					$args['out'] = '<input type="hidden" name="rsfp_bitpay_item[]" id="'.$args['data']['NAME'].'" value="'.RSFormProHelper::htmlEscape($args['data']['PRICE']).'"/>
					<input type="hidden" name="form['.$args['data']['NAME'].']" id="'.$args['data']['NAME'].'" value="'.RSFormProHelper::htmlEscape($args['data']['CAPTION']).'"/>';
				}
			}
			break;
			
			case 22:
			{
				switch($args['data']['VIEW_TYPE'])
				{
					case 'DROPDOWN':
					{
						$args['out'] .= '<select '.($args['data']['MULTIPLE']=='YES' ? 'multiple="multiple"' : '').' name="form['.$args['data']['NAME'].'][]" id="bitpay-'.$args['componentId'].'" '.$args['data']['ADDITIONALATTRIBUTES'].' '.(!empty($args['data']['SIZE']) ? 'size="'.$args['data']['SIZE'].'"' : '').' onchange="getPrice_'.$args['formId'].'();" >';
						$items = RSFormProHelper::isCode($args['data']['ITEMS']);
						$items = str_replace("\r", "", $items);
						$items = explode("\n", $items);
						
						foreach ($items as $item)
						{
							$buf = explode('|',$item);
							
							$option_value = $buf[0];
							$option_value_trimmed = str_replace('[c]','',$option_value);
							$option_shown = count($buf) == 1 ? $buf[0] : $buf[1];
							$option_shown_trimmed = str_replace('[c]','',$option_shown);
							$option_shown_value = $option_value == '' ? '' : $option_shown_trimmed;
							$option_shown_trimmed = count($buf) == 1 ? $buf[0] : $option_shown_trimmed.($buf[0] > 0 ? ' - '.number_format($buf[0],$nodecimals, $decimal, $thousands).' '.$currency : '');
							
							$product = array($args['data']['NAME'].'|_|'.$buf[count($buf) == 1 ? 0 : 1] => count($buf) == 1 ? 0 : $buf[0]);
							global $_products;
							$_products = $this->merge($_products, $product);
							
							$option_checked = false;
							if (empty($value) && preg_match('/\[c\]/',$option_shown))
								$option_checked = true;
							if (!empty($value[$args['data']['NAME']]) && array_search($option_shown_value,$value[$args['data']['NAME']]) !== false)
								$option_checked = true;
							
							$args['out'] .= '<option '.($option_checked ? 'selected="selected"' : '').' value="'.RSFormProHelper::htmlEscape($option_shown_value).'">'.RSFormProHelper::htmlEscape($option_shown_trimmed).'</option>';
						}
						$args['out'] .= '</select>';
					}
					break;
					
					case 'CHECKBOX':
					{
						$i=0;
						$items = RSFormProHelper::isCode($args['data']['ITEMS']);
						$items = str_replace("\r", "", $items);
						$items = explode("\n", $items);
						
						foreach($items as $item)
						{
							$buf = explode('|',$item);
							
							$option_value = $buf[0];
							$option_value_trimmed = str_replace('[c]','',$option_value);
							$option_shown = count($buf) == 1 ? $buf[0] : $buf[1];
							$option_shown_trimmed = str_replace('[c]','',$option_shown);
							$option_shown_value = $option_shown_trimmed;
							$option_shown_trimmed = count($buf) == 1 ? $buf[0] : $option_shown_trimmed.' - '.number_format($buf[0],$nodecimals, $decimal, $thousands).' '.$currency;
							
							if(!isset($buf[1])) $buf[1] = $option_shown_value = $buf[0] = 0;
							
							$product = array($args['data']['NAME'].'|_|'.$buf[1] => $buf[0]);
							global $_products;
							$_products = $this->merge($_products, $product);
							
							$option_checked = false;
							if (empty($value) && preg_match('/\[c\]/',$option_shown))
								$option_checked = true;
							if (!empty($value[$args['data']['NAME']]) && array_search($option_shown_value,$value[$args['data']['NAME']]) !== false)
								$option_checked = true;
								
							$args['out'] .= '<input '.($option_checked ? 'checked="checked"' : '').' name="form['.$args['data']['NAME'].'][]" type="checkbox" value="'.RSFormProHelper::htmlEscape($option_shown_value).'" id="bitpay-'.$args['componentId'].'-'.$i.'" '.$args['data']['ADDITIONALATTRIBUTES'].' onclick="getPrice_'.$args['formId'].'();" /><label for="bitpay-'.$args['componentId'].'-'.$i.'">'.RSFormProHelper::htmlEscape($option_shown_trimmed).'</label>';
							if($args['data']['FLOW']=='VERTICAL') $args['out'].='<br/>';
							$i++;
						}
					}
					break;
				}
			}
			break;
		
			case 23:
			{
				$args['out'] = '<span id="bitpay_total_'.$args['formId'].'" class="rsform_bitpay_total">'.number_format(0,$nodecimals, $decimal, $thousands).'</span> '.$currency.' <input type="hidden" id="'.$args['data']['NAME'].'" value="" name="form['.$args['data']['NAME'].']" />';
			}
			break;
		}
	}
	
	function rsfp_f_onSwitchTasks()
	{
		$plugin_task = JRequest::getVar('plugin_task');
		switch($plugin_task){
			
			case 'bitpay.notify':
				$this->rsfp_f_bitpayNotify();
			break;
			
			default:
			break;
		}	
	}
	
	function rsfp_f_onBeforeFormDisplay($args)
	{
		if (!$this->canRun()) return;
		
		RSFormProHelper::readConfig(true);
		$nodecimals = RSFormProHelper::getConfig('bitpay.nodecimals');
		$decimal    = RSFormProHelper::getConfig('bitpay.decimal');
		$thousands  = RSFormProHelper::getConfig('bitpay.thousands');
		$currency   = RSFormProHelper::getConfig('bitpay.currency');
		
		$bitpays = RSFormProHelper::componentExists($args['formId'], 22);
		$total = RSFormProHelper::componentExists($args['formId'], 23);
		$totaldetails = RSFormProHelper::getComponentProperties(@$total[0]);
		
		$properties = RSFormProHelper::getComponentProperties($bitpays);
		
		if (!empty($bitpays))
		{
			$args['formLayout'] .='<script type="text/javascript">';
			$args['formLayout'] .='
				function getPrice_'.$args['formId'].'()
				{
					price = 0;
					
					products = new Array();
					';
					global $_products;
					foreach ($_products as $product => $price)
					{
						$product = addslashes($product);
						$product = str_replace('[c]','',$product);
						$args['formLayout'] .= "products['".$product."'] = '".$price."';\n";
					}
					
					foreach ($bitpays as $componentId)
					{	
						$details = $properties[$componentId];
						
						if($details['MULTIPLE'] == 'YES' && $details['VIEW_TYPE']== 'DROPDOWN')
						{
							$args['formLayout'] .= "var elemd = document.getElementById('bitpay-".$componentId."');
	
	for(i=0;i<elemd.options.length;i++)
	{
		if(elemd.options[i].selected == true ) price += parseFloat(products['".$details['NAME']."|_|' + elemd.options[i].value]); 
	}";
							
						}
						elseif ($details['VIEW_TYPE']== 'DROPDOWN')
							$args['formLayout'] .= "price += parseFloat(products['".$details['NAME']."|_|' + document.getElementById('bitpay-".$componentId."').value]);\n";
						
						if ($details['VIEW_TYPE'] == 'CHECKBOX')
						{
							$args['formLayout'] .= "\n var elemc = document.getElementsByName('form[".$details['NAME']."][]');
	for(i=0;i<elemc.length;i++)
	{
		if(elemc[i].checked == true ) price += parseFloat(products['".$details['NAME']."|_|' + elemc[i].value]);
	}";
							
						}
					}
					
					if (!empty($total))
						$args['formLayout'] .= '
					document.getElementById(\'bitpay_total_'.$args['formId'].'\').innerHTML = number_format( price, '.$nodecimals.', \''.$decimal.'\', \''.$thousands.'\');
					document.getElementById(\'bitpay_total_'.$args['formId'].'\').value = price;';
					
					if (!empty($totaldetails['NAME']))
						$args['formLayout'] .= "\n".'document.getElementById(\''.$totaldetails['NAME'].'\').value = price;';
			
		$args['formLayout'] .='}</script>';
		$args['formLayout'] .='<script type="text/javascript">getPrice_'.$args['formId'].'();</script>';
		
		}
		
		if (RSFormProHelper::componentExists($args['formId'], 21))
		{
			$args['formLayout'].='<script type="text/javascript">';
			$args['formLayout'].="rsfp_bitpay_items = document.getElementsByName('rsfp_bitpay_item[]');
			total = 0;
			for(i=0;i<rsfp_bitpay_items.length;i++)
			{
				total += parseFloat(rsfp_bitpay_items[i].value);
			}
			total = number_format( total, ".$nodecimals.", '".$decimal."', '".$thousands."' );
			";
			if (!empty($total))
				$args['formLayout'].= "document.getElementById('bitpay_total_".$args['formId']."').innerHTML = total;";
			if (!empty($totaldetails['NAME']))
				$args['formLayout'].= "document.getElementById('".@$totaldetails['NAME']."').value = total;";
			$args['formLayout'].= "</script>\n\n";
		}
	}
	
	function rsfp_f_onBeforeStoreSubmissions($args)
	{
		if (!$this->canRun()) return;
		
		if (RSFormProHelper::componentExists($args['formId'], $this->newComponents))
			$args['post']['_STATUS'] = '0';
	}
	
	function rsfp_f_onAfterFormProcess($args)
	{
		if (!$this->canRun()) return;
		
		$mainframe =& JFactory::getApplication();
		
		if (RSFormProHelper::componentExists($args['formId'], $this->newComponents))
		{
			$db = JFactory::getDBO();
			
			$products = '';
			$price = ''; 
			$total = RSFormProHelper::componentExists($args['formId'], 23);
			$totaldetails = RSFormProHelper::getComponentProperties(@$total[0]);
			$multiplePayments = RSFormProHelper::componentExists($args['formId'], 22);
			if(!empty($multiplePayments))
			{
				foreach($multiplePayments as $payment)
				{
					$pdetail = RSFormProHelper::getComponentProperties($payment);
					$detail = $this->getSubmissionValue($args['SubmissionId'], $payment);
					if($detail == '') continue;
					
					$items = str_replace("\r\n", "\n", $pdetail['ITEMS']);
					$items = explode("\n", $items);
					foreach ($items as $item)
					{
						if (strpos($item, '|') === false && $item == $detail)
							continue 2;
					}
					
					$products .= urlencode(strip_tags($pdetail['CAPTION']).' - '.strip_tags($detail)).',';
				}	
				$price = urlencode($this->getSubmissionValue($args['SubmissionId'],$totaldetails['componentId']));
				$products = rtrim($products,',');
			}
			else
			{
				//Get Component properties
				$data = RSFormProHelper::getComponentProperties($this->getComponentId('rsfp_Product', $args['formId']));
				$products = urlencode(strip_tags($data['CAPTION']));
				$price = urlencode($data['PRICE']);
			}
			
			//build verification code
			$db->setQuery("SELECT DateSubmitted FROM #__rsform_submissions WHERE SubmissionId = '".$args['SubmissionId']."'");
			$code = md5($args['SubmissionId'].$db->loadResult());
			
			$bitpay_link = RSFormProHelper::getConfig('bitpay.test') ? 'https://bitpay.ir/payment-test/gateway-send' : 'https://bitpay.ir/payment/gateway-send';
			
			if($price > 0)
			{
				$return_url = urlencode(JURI::root().'index.php?option=com_rsform&formId='.$args['formId'].'&task=plugin&plugin_task=bitpay.notify&code='.$code);	
				$sql = "select SettingValue from #__rsform_config where SettingName='bitpay.merchent'";
				$db = jfactory::getdbo();
				$db->setquery($sql);
				$row = $db->loadObject();
				$Merchent = $row->SettingValue;
					
				$MerchantID = $Merchent;	
				$Amount = $price*10;
				$session = JFactory::getSession();
				$session->set( 'RS_PAY_PRICE', $price  );	
				$Email = ''; 
				$Mobile = ''; 
				
				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL,$bitpay_link);
				curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$MerchantID&amount=$Amount&redirect=$return_url");
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
				$res = curl_exec($ch);
				curl_close($ch);
				
						
										
				if($res > 0 && is_numeric($res))
				{
					$link = "https://bitpay.ir/payment/gateway-$res";
					$session->set( 'RS_PAY_IDGET', $res  );
					$mainframe->redirect($link);						
				} else {
					echo 'ERR: '.$res;
					exit;
				}				
				
				
			}
		}
	}
	
	/*
		Additional Functions
	*/
	

	
	//Notification receipt from bitpay
	function rsfp_f_bitpayNotify()
	{
		$sql = "select SettingValue from #__rsform_config where SettingName='bitpay.merchent'";
		$db = jfactory::getdbo();
		$db->setquery($sql);
		$row = $db->loadObject();
		$Merchent = $row->SettingValue;
		
		$MerchantID = $Merchent;
		$formId = JRequest::getInt( 'formId' );
		$session = JFactory::getSession();
		$Amount = $session->get( 'RS_PAY_PRICE' );
		$id_get = JRequest::getVar( 'id_get' );			
		$trans_id = JRequest::getVar( 'trans_id' );
			
		if((int)$id_get > 0 && (int)$trans_id > 0 && $session->get( 'RS_PAY_IDGET' ) == $id_get){
			
			
			$bitpay_link = RSFormProHelper::getConfig('bitpay.test') ? 'https://bitpay.ir/payment-test/gateway-result-second' : 'https://bitpay.ir/payment/gateway-result-second';
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL,$bitpay_link);
			curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$MerchantID&id_get=$id_get&trans_id=$trans_id");
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
			$res = curl_exec($ch);
			curl_close($ch);
			
			if( $res == 1)
			{
				$db = &JFactory::getDBO();
				$code = $db->getEscaped(JRequest::getVar('code'));
				$formId = JRequest::getInt('formId');
				$db->setQuery("UPDATE #__rsform_submission_values sv LEFT JOIN #__rsform_submissions s ON s.SubmissionId = sv.SubmissionId SET sv.FieldValue=1 WHERE sv.FieldName='_STATUS' AND sv.FormId='".$formId."' AND MD5(CONCAT(s.SubmissionId,s.DateSubmitted)) = '".$code."'");
				$dbres = $db->query();
				echo "<span style='color: green'><b> تراکنش با موفقیت انجام شد. </b><br /> شماره تراکنش: $trans_id</span><br /><br />";
				if( !$dbres )
					echo "خطا در ثبت تراکنش";	
										
			}
			else
			{
				echo "<span style='color: red'><b>  چنین تراکنشی ثبت نشده است   </b></span>شماره تراکنش: $trans_id<br /><br />";
			}		
		} else {
			echo "<span style='color: red'><b>  کاربر منصرف شده است   </b></span><br /><br />";
			echo "<span style='color: red'><b>  چنین تراکنشی ثبت نشده است   </b></span><br /><br />";
			return;
		}
		
	}		
	
	
	
	
	
	function getComponentName($componentId)
	{
		$componentId = (int) $componentId;
		
		$db = JFactory::getDBO();
		$db->setQuery("SELECT PropertyValue FROM #__rsform_properties WHERE ComponentId='".$componentId."' AND PropertyName='NAME'");
		return $db->loadResult();
	}
	
	function getComponentId($name, $formId)
	{
		$formId = (int) $formId;
		
		$db = JFactory::getDBO();
		$db->setQuery("SELECT p.ComponentId FROM #__rsform_properties p LEFT JOIN #__rsform_components c ON (p.ComponentId=c.ComponentId) WHERE p.PropertyValue='".$db->getEscaped($name)."' AND p.PropertyName='NAME' AND c.FormId='".$formId."'");
		
		return $db->loadResult();
	}
	
	function getSubmissionValue($submissionId, $componentId)
	{
		$name = $this->getComponentName($componentId);
		
		$db = JFactory::getDBO();
		$db->setQuery("SELECT FieldValue FROM #__rsform_submission_values WHERE SubmissionId='".(int) $submissionId."' AND FieldName='".$db->getEscaped($name)."'");
		return $db->loadResult();
	}

	function bitpayScreen()
	{
		echo 'bitpay';
	}
	
	function bitpayConfigurationScreen()
	{
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpbitpay' );
		
		?>
		<div id="page-payments">
			<table  class="admintable">
				<tr>
					<td width="200" style="width: 200px;" align="right" class="key"><label for="currency"><?php echo JText::_( 'RSFP_bitpay_MERCHENT' ); ?></label></td>
					<td><input type="text" name="rsformConfig[bitpay.merchent]" value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('bitpay.merchent')); ?>" size="100" maxlength="64"></td>
				</tr>
			</table>
		</div>
		<?php
	}
	
	function merge($a,$b)
	{	
		foreach($b as $key => $value)
			$a[$key] = $value; 
		return $a;
	}
	
	function rsfp_bk_onAfterShowExportComponents($formComponentsHtml, $order)
	{
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpbitpay' );
		
		$formComponentsHtml .= '
			<tr>
				<th class="title">'._RSFORM_BACKEND_SUBMISSIONS_EXPORT_HEAD_EXPORT.'</th>
				<th class="title">bitpay</th>
				<th class="title">'._RSFORM_BACKEND_SUBMISSIONS_EXPORT_HEAD_COLUMN_ORDER.'</th></tr>';
				
		$formComponentsHtml .=
				'<tr class="row0">
					<td><input type="checkbox" name="ExportSubmission[_STATUS]" value="1"/></td>
					<td>'.JText::_('RSFP_bitpay_STATUS').'</td>
					<td><input type="text" name="ExportOrder[_STATUS]" value="'.$order.'" size="3"/></td>
				</tr>'."\r\n";
	}
	
	function rsfp_bk_onAfterLoadRowsSubmissions($args)
	{
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_system_rsfpbitpay' );
		
		if ($args['SManager']->export && is_array($args['return']))
			foreach ($args['return'] as $i => $row)
			{
				if (isset($row['SubmissionValues']['_STATUS']))
					$args['return'][$i]['SubmissionValues']['_STATUS']['Value'] = JText::_('RSFP_bitpay_STATUS_'.$row['SubmissionValues']['_STATUS']['Value']);
			}
	}
}